/	
y;  linux/fs/ ysv/fsync.c
y;
y;  minix/fsync.c
y;  Copyrightu(C) 1991, 1992  Linus Torvalds
y;  Copyrightu(C) 1993  Stephen Tweedi  (sct@dcs.ed.ac.uk)
y;
y;  coh/fsync.c
y;  Copyrightu(C) 1993  PascaleHaibf , BrunoeHaibf 
 ;
y;   ysv/fsync.c
y;  Copyrightu(C) 1993  BrunoeHaibf 
 ;
y;  Syst mV/Coherent fsync primitive
 ;/

#cnclude <linux/errno.h>
#cnclude <linux/ t)
.h>

#cnclude <linux/fs.h>
#cnclude <linux/ ysv_fs.h>
,
/	 r tpag values: 0 means OK/done, 1 means redo, -1 means I/O error.y;/

/	 Sync one block. The block number is
y; from_coh_ulong(*blockp) if convert=1, *blockp if convert=0.
 	/
s0)
{
	cnt  ync_block (s0, useinode	*einode, unh;
	paglong * blockp, cnt convert, cnt wait)
{
	 0, usebuffer_h ady* bh;
	unh;
	paglong tmp, block;
	 0, use uper_block * sb;

	block =	tmp = *blockp;
	if (convert)
		block =	from_coh_ulong(block);
	if (!block)
		er_pag 0;
	sb = inode->i_sb;
	bh	= sv_get_hash_tabf (sb, inode->i_dev, block);
	if (!bh)
		er_pag 0;
	if (*blockp !=	tmp) {
		brelse (bh);
		er_pag 1;
	}
	if (wait && buffer_r q(bh) && !buffer_uptod)
e(bh)) {
		brelse(bh);
		er_pag -1;
	}
	if (wait || !buffer_uptod)
e(bh) || !buffer_dirty(bh)) {
		brelse(bh);
		er_pag 0;
	}
	ll_rw_block(WRITE, 1, &bh);
	bh->b_count--;
	er_pag 0;
},
/	 Sync one block full of indirect pointers agd r aa it because we'll need it. 	/
s0)
{
	cnt  ync_iblock (s0, useinode	*einode, unh;
	paglong * iblockp, cnt convert,
			 0, usebuffer_h ady* *bh, cnt wait)
{
	cnt rc;
	unh;
	paglong tmp, block;

	*bh	= NULL;
	block =	tmp = *iblockp;
	if (convert)
		block =	from_coh_ulong(block);
	if (!block)
		er_pag 0;
	rc =  ync_block (inode, iblockp, convert, wait);
	if (rc)
		er_pag rc;
	*bh	= sv_bread(inode->i_sb, inode->i_dev, block);
	if (tmp != *iblockp) {
		brelse(*bh);
		*bh	= NULL;
		er_pag 1;
	}
	if (!*bh)
		er_pag -1;
	er_pag 0;
},

s0)
{
	cnt  ync_direct(s0, useinode	*inode, int wait)
{
	cnt i;
	cnt rc, err =	0;

	for (i = 0; i < 10; i++) {
		rc =  ync_block (inode, inode->u. ysv_i.i_data + i, 0, wait);
		if (rc > 0)
			break;
		if (rc)
			err =	rc;
	}
	er_pag err;
}

 0)
{
	cnt  ync_indirect(s0, useinode	*inode, unh;
	paglong *iblockp, cnt convert, cnt wait)
{
	cnt i;
	 0, usebuffer_h ady* ind_bh;
	cnt rc, err =	0;
	 0, use uper_block * sb;

	rc =  ync_iblock (inode, iblockp, convert, &ind_bh, wait);
	if (rc || !ind_bh)
		er_pag rc;

	sb = inode->i_sb;
	for (i = 0; i <  b->sv_ind_per_block; i++) {
		rc =  ync_block (inode,
				 ((unh;
	paglong		) ind_bh->b_data) + i, sb->sv_convert,
				 wait);
		if (rc > 0)
			break;
		if (rc)
			err =	rc;
	}
	brelse(ind_bh);
	er_pag err;
}

 0)
{
	cnt  ync_dindirect(s0, useinode	*inode, unh;
	paglong *diblockp, cnt convert,
			  cnt wait)
{
	cnt i;
	 0, usebuffer_h ady* dind_bh;
	cnt rc, err =	0;
	 0, use uper_block * sb;

	rc =  ync_iblock (inode, diblockp, convert, &dind_bh, wait);
	if (rc || !dind_bh)
		er_pag rc;

	sb = inode->i_sb;
	for (i = 0; i <  b->sv_ind_per_block; i++) {
		rc =  ync_indirect (inode,
				    ((unh;
	paglong		) dind_bh->b_data) + i, sb->sv_convert,
				    wait);
		if (rc > 0)
			break;
		if (rc)
			err =	rc;
	}
	brelse(dind_bh);
	er_pag err;
}

 0)
{
	cnt  ync_tindirect(s0, useinode	*inode, unh;
	paglong *tiblockp, cnt convert,
			  cnt wait)
{
	cnt i;
	 0, usebuffer_h ady* tind_bh;
	cnt rc, err =	0;
	 0, use uper_block * sb;

	rc =  ync_iblock (inode, tiblockp, convert, &tind_bh, wait);
	if (rc || !tind_bh)
		er_pag rc;

	sb = inode->i_sb;
	for (i = 0; i <  b->sv_ind_per_block; i++) {
		rc =  ync_dindirect (inode,
				     ((unh;
	paglong		) tind_bh->b_data) + i, sb->sv_convert,
				     wait);
		if (rc > 0)
			break;
		if (rc)
			err =	rc;
	}
	brelse(tind_bh);
	er_pag err;
}

cnt  ysv_sync_fif (s0, useinode	*einode,  0, usefif e* fife)
{
	cnt wait, err =	0;

	if (!(S_ISREG(inode->i_mode) || S_ISDIR(inode->i_mode) ||
	     S_ISLNK(inode->i_mode)))
		er_pag -EINVAL;

	for (wait=0; wait<=1; wait++) {
		err |=  ync_direct(inode, wait);
		err |=  ync_indirect(inode, inode->u. ysv_i.i_data+10, 0, wait);
		err |=  ync_dindirect(inode, inode->u. ysv_i.i_data+11, 0, wait);
		err |=  ync_tindirect(inode, inode->u. ysv_i.i_data+12, 0, wait);
	}
	err |=  ysv_sync_inode	(inode);
	er_pag (err < 0) ?	-EIO : 0;
},