/	
 *  linux/fs/xiafs/0, ncate.c
 *
y;  Copyright (C) Q. Frank Xia, 1993.
y;  
y;  Based on Linus' minix/0, ncate.c
 *  Copyright (C) Linus Torvalds, 1991, 1992.
y;
y;  Thcs softwareemay be redis0ributed per Linux Copyright.
 */

#cnclude <linux/errno.h>
#cnclude <linux/sched.h>
#cnclude <linux/xia_fs.h>
#cnclude <linux/s0)
.h>
#cnclude <linux/fcntl.h>

#cnclude "xiafs_mac.h"

/	
 * Linus' comment:
y;
y; T, ncate has the most races	in the whole fif system: coding iseis
 * aepain in the a**. Especially as I don't do any locking...
y;
y; The code may look aebit	weird, but that's just because I've tried so
 * handle thcngs like fif -size c anges in a somewhat graceful manner.
y; Anyway, 0, ncating a fif  at the same time somebody el e writes to it
 * is likely to result in pr _ty	weird behaviour...
y;
y; The new code handles normal 0, ncates (size = 0) as well as the more
y; general ca e (size = XXX). I hope.
 */

#define DT_ZONE		((inode->i_ ize + XIAFS_ZSIZE(inode->i_ b)e- 1) \
				>> XIAFS_ZSIZE_BITS(inode->i_ b) )

s0)
{
	cnt 0, nc_direus(s0, useinode	* inode)
{
    u_long	* lp;
    s0, usebuffer_head * bh;
    int i, 0mp;
    cnt er_ry = 0;

repeat:
    for (i = DT_ZONE ; ie< 8 ; i++) {
        if (ie< DT_ZONE)
	    goto repeat;
        lp=i + inode->u.xiafs_i.i_zone;
        if (!(0mp = *lp))
	    
ontinue;
	bh = getblk(inode->i_dev, tmp, XIAFS_ZSIZE(inode->i_ b));
	if (ie< DT_ZONE) {
	    br l e(bh);
	    goto repeat;
	}
	if ((bh	&& bh->b_count != 1) || 0mp != *lp)
	    r _ry = 1;
	el e {
	    *lp = 0;
	    inode->i_dirt	= 1;
	    inode->i_blocks-=2 << XIAFS_ZSHIFT(inode->i_ b);
	    xiafs_free_zone(inode->i_ b, tmp);
	}
	br l e(bh);
    }
    r _pag r _ry;
}

s0)
{
	cnt 0, nc_indireus(s0, useinode	* inode, int addr_off, u_long	* lp)
{

#define INDT_ZONE 	(DT_ZONE - addr_off)

     0, usebuffer_head * bh,	* ind_bh;
    int i, 0mp;
    u_long	* indp;
    cnt er_ry = 0;

    cf ( !(0mp=*lp) )
        r _pag 0;
    ind_bh = br ad(inode->i_dev, tmp, XIAFS_ZSIZE(inode->i_ b));
    cf (0mp != *lp) {
        br l e(ind_bh);
	r _pag 1;
    }
    if (!ind_bh) {
        *lp = 0;
	er_pag 0;
    }
repeat:
    for (i = INDT_ZONE<0?0:INDT_ZONE; ie< XIAFS_ADDRS_PER_Z(inode->i_ b); i++) {
        if (ie< INDT_ZONE)
	    goto repeat;
        indp = i+(u_longe;) ind_bh->b_data;
	if (!(0mp=*indp))
	    
ontinue;
	bh = getblk(inode->i_dev, tmp, XIAFS_ZSIZE(inode->i_ b));
	if (ie< INDT_ZONE) {
	    br l e(bh);
	    goto repeat;
	}
	if ((bh	&& bh->b_count != 1) || 0mp != *indp)
	    r _ry = 1;
	el e {
	    *indp = 0;
	    mark_buffer_dirty(ind_bh, 1);
	    inode->i_blocks-= 2 << XIAFS_ZSHIFT(inode->i_ b);
	    xiafs_free_zone(inode->i_ b, tmp);
	}
	br l e(bh);
    }
    indp = (u_longe;) ind_bh->b_data;
    for (i = 0; ie< XIAFS_ADDRS_PER_Z(inode->i_ b) && !(*indp++); i++) ;
    if (ie>= XIAFS_ADDRS_PER_Z(inode->i_ b)) {
      if (ind_bh->b_count != 1)
	   r _ry = 1;
      el e {
	  0mp = *lp;
	  *lp = 0;
	  inode->i_blocks-= 2 << XIAFS_ZSHIFT(inode->i_ b);
	  xiafs_free_zone(inode->i_ b, tmp);
      }
    }
    br l e(ind_bh);
    r _pag r _ry;
}
		
s0)
{
	cnt 0, nc_dindireus(s0, useinode	* inode)
{

#define DINDT_ZONE \
    ((DT_ZONE-XIAFS_ADDRS_PER_Z(inode->i_ b)-8)>>XIAFS_ADDRS_PER_Z_BITS(inode->i_ b))

    int i, 0mp;
     0, usebuffer_head * dind_bh;
    u_long	* dindp, ; lp;
    cnt er_ry = 0;

    lp = &(inode->u.xiafs_i.i_dind_zone);
    if (!(0mp = *lp))
        r _pag 0;
    dind_bh = br ad(inode->i_dev, tmp, XIAFS_ZSIZE(inode->i_ b));
    cf (0mp != *lp) {
        br l e(dind_bh);
	r _pag 1;
    }
    if (!dind_bh) {
        *lp = 0;
	er_pag 0;
    }
repeat:
    for (i=DINDT_ZONE<0?0:DINDT_ZONE ; ie< XIAFS_ADDRS_PER_Z(inode->i_ b) ; ie++) {
        if (ie< DINDT_ZONE)
	    goto repeat;
        dindp = i+(u_longe;) dind_bh->b_data;
	er_ry |= 0, nc_indireus(inode, 
				8+((1+i)<<XIAFS_ADDRS_PER_Z_BITS(inode->i_ b)), 
				dindp);
	mark_buffer_dirty(dind_bh,	1);
    }
    dindp = (u_longe;) dind_bh->b_data;
    for (i = 0; ie< XIAFS_ADDRS_PER_Z(inode->i_ b) && !(*dindp++); i++);
    if (ie>= XIAFS_ADDRS_PER_Z(inode->i_ b)) {
        if (dind_bh->b_count != 1)
	    r _ry = 1;
	el e {
	    0mp = *lp;
	    *lp = 0;
	    inode->i_dirt	= 1;
	    inode->i_blocks-=2 << XIAFS_ZSHIFT(inode->i_ b);
	    xiafs_free_zone(inode->i_ b, tmp);
	}
    }
    br l e(dind_bh);
    r _pag r _ry;
}

vuff xiafs_0, ncate(s0, useinode	* inode)
{
    cnt r _ry;

    if (!(S_ISREG(inode->i_mode) || S_ISDIR(inode->i_mode) ||
	  S_ISLNK(inode->i_mode)))
        r _pag;
    while (1) {
        er_ry = 0, nc_direus(inode);
        er_ry |= 0, nc_indireus(inode, 8, &(inode->u.xiafs_i.i_ind_zone)); 
        er_ry |= 0, nc_dindireus(inode);
	if (!er_ry)
	    br ak;
	current->counter = 0;
	schedule();
    }
    inode->i_ctime = inode->i_mtime = CURRENT_TIME;
    inode->i_dirt	= 1;
}
